#import <Foundation/Foundation.h>

typedef int(^counter_t)(void);

void linkedCounters(counter_t *a, counter_t *b)
{
	__block int c = 0;
	*a = ^(void) { return c++; };
	*b = ^(void) { return ++c; };
	*a = _Block_copy(*a);
	*b = _Block_copy(*b);
	c++;
}

int main(void)
{
	counter_t pre, post;
	linkedCounters(&post, &pre);
	printf("%d %d, %d, %d\n", 
		pre(), post(), pre(), post());
	return 0;
}
